package mygame;

import com.jme3.app.SimpleApplication;
import com.jme3.light.AmbientLight; // there are other types of lights like light.DirectionalLight
import com.jme3.material.Material;
import com.jme3.math.Vector3f;
import com.jme3.scene.Spatial;
import com.jme3.terrain.geomipmap.TerrainLodControl;
import com.jme3.terrain.geomipmap.TerrainQuad;
import com.jme3.terrain.heightmap.AbstractHeightMap;
import com.jme3.terrain.heightmap.ImageBasedHeightMap;
import com.jme3.texture.Texture;
import com.jme3.texture.Texture.WrapMode;
import com.jme3.util.SkyFactory;

/**
 * Every JME3 game is an instance of the com.jme3.app.SimpleApplication class.
 * The SimpleApplication class is the simplest example of an application: It
 * manages a 3D scene graph, checks for user input, updates the game state, and
 * automatically draws the scene to the screen. These are the core features of a
 * game engine. You extend this simple application and customize it to create
 * your game.
 *
 * @author G. Amador \& A. Gomes
 */
public class Main extends SimpleApplication {

    private TerrainQuad terrain;
    Material mat_terrain;
    /*
     * You start every JME3 game from the main() method, as every standard Java
     * application: 
     * 1 - Instantiate your SimpleApplication-based class. 
     * 2 - The application's start() method to start the game engine.
     *
     * @param args
     */

    public static void main(String[] args) {
        Main app = new Main();          // instantiate the game
        app.setDisplayFps(false);       // TODO: UNCOMMENT TO HIDE FPS INFO ON APPLICATION RUN
        app.setDisplayStatView(false);  // TODO: UNCOMMENT TO HIDE STATS VIEW INFO ON APPLICATION RUN
        //app.setShowSettings(false);     // TODO: UNCOMMENT TO HIDE SETTINGS MENU ON STARTUP
        app.start();                    // start the game
    }

    /**
     * Method that is automatically called once at the beginning when the
     * application starts. Every JME3 game must have this method. In the
     * simpleInitApp() method, you load game objects before the game starts.
     */
    @Override
    public void simpleInitApp() {
        // We speedup the movement of the flyby camera default camera
        flyCam.setMoveSpeed(100);

        /* create a SkyBox of dimension */
        /**
         * BEGIN OF EXERCISE 3 (Step 3): uncomment code as indicated in comments
         * in the following TODO's for Step 3.
         */
        // TODO: (Sub-Step 3.1) UNCOMMENT THE FOLLOWING BLOCK
/*        
        Texture westTex = assetManager.loadTexture("Textures/Skybox/SkyBox2_west.jpg");
        Texture eastTex = assetManager.loadTexture("Textures/Skybox/SkyBox2_east.jpg");
        Texture northTex = assetManager.loadTexture("Textures/Skybox/SkyBox2_north.jpg");
        Texture southTex = assetManager.loadTexture("Textures/Skybox/SkyBox2_south.jpg");
        Texture upTex = assetManager.loadTexture("Textures/Skybox/SkyBox2_up.jpg");
        Texture downTex = assetManager.loadTexture("Textures/Skybox/SkyBox2_down.jpg");

        final Vector3f normalScale = new Vector3f(-1, 1, 1);
        Spatial skySpatial = SkyFactory.createSky(
                assetManager,
                westTex,
                eastTex,
                northTex,
                southTex,
                upTex,
                downTex,
                normalScale);
        rootNode.attachChild(skySpatial);
*/
        // END OF EXERCISE 4 (Step 4). -----------------------------------------        

        /*Create terrain material and load four textures into it.*/
        /**
         * BEGIN OF EXERCISE 4 (Step 4): uncomment code as indicated in comments
         * in the following TODO's for Step 4.
         */
        // TODO: (Sub-Step 4.1) UNCOMMENT THE FOLLOWING BLOCK
/*        
        mat_terrain = new Material(assetManager,
                "Common/MatDefs/Terrain/Terrain.j3md");

        //Add ALPHA map (for red-blue-green coded splat textures)
        mat_terrain.setTexture("Alpha", assetManager.loadTexture(
                "Textures/Terrain/splat/alphamap.png"));

        //Add GRASS texture into the red layer (Tex1).
        Texture grass = assetManager.loadTexture(
                "Textures/Terrain/splat/grass.jpg");
        grass.setWrap(WrapMode.Repeat);
        mat_terrain.setTexture("Tex1", grass);
        mat_terrain.setFloat("Tex1Scale", 64f);

        //Add DIRT texture into the green layer (Tex2)
        Texture dirt = assetManager.loadTexture(
                "Textures/Terrain/splat/dirt.jpg");
        dirt.setWrap(WrapMode.Repeat);
        mat_terrain.setTexture("Tex2", dirt);
        mat_terrain.setFloat("Tex2Scale", 32f);

        //Add ROAD texture into the blue layer (Tex3)
        Texture rock = assetManager.loadTexture(
                "Textures/Terrain/splat/road.jpg");
        rock.setWrap(WrapMode.Repeat);
        mat_terrain.setTexture("Tex3", rock);
        mat_terrain.setFloat("Tex3Scale", 128f);

        //Create the height map
        AbstractHeightMap heightmap;
        Texture heightMapImage = assetManager.loadTexture(
                "Textures/Terrain/splat/mountains512.png");
        heightmap = new ImageBasedHeightMap(heightMapImage.getImage());
        heightmap.load();

        //We have prepared material and heightmap. Now we create the actual
        //terrain: Create a TerrainQuad and name it "my terrain". A good value
        //for terrain tiles is 64x64 -- so we supply 64+1=65. We prepared a
        //heightmap of size 512x512 -- so we supply 512+1=513. As LOD step
        //scale we supply Vector3f(1,1,1). We supply the prepared heightmap
        //itself.
        int patchSize = 65;
        terrain = new TerrainQuad("my terrain", patchSize, 513, heightmap.getHeightMap());

        ///We give the terrain its material, position & scale it, and attach it.
        terrain.setMaterial(mat_terrain);
        terrain.setLocalTranslation(0, -100, 0);
        terrain.setLocalScale(2f, 1f, 2f);
        rootNode.attachChild(terrain);

        //The LOD (level of detail) depends on were the camera is:
        TerrainLodControl control = new TerrainLodControl(terrain, getCamera());
        terrain.addControl(control);
*/
        // END OF EXERCISE 4 (Step 4). -----------------------------------------

        /**
         * add ambient light. Since, ambient light does not in reality exist we
         * shall call it god because like ambient light god is everywhere ...
         * assuming god exists obviously. If it/he/she does or doesn't exist is
         * in the scope of theology not science.
         *
         */
        AmbientLight god = new AmbientLight(); //because god is light and god is everywere 
        //got..setDirection(new Vector3f(-10.0f, -20.0f, -10.0f));    // The direction where the light is pointing (-1, -1, -1) and the light position (10, 20, 10)
        rootNode.addLight(god);
    }
}
